import { API as GithubAPI } from 'decap-cms-backend-github';
import type { Config as GitHubConfig, Diff } from 'decap-cms-backend-github/src/API';
import type { FetchError } from 'decap-cms-lib-util';
import type { Octokit } from '@octokit/rest';
type Config = Omit<GitHubConfig, 'getUser'> & {
    apiRoot: string;
    tokenPromise: () => Promise<string>;
    commitAuthor: {
        name: string;
    };
    isLargeMedia: (filename: string) => Promise<boolean>;
};
export default class API extends GithubAPI {
    tokenPromise: () => Promise<string>;
    isLargeMedia: (filename: string) => Promise<boolean>;
    constructor(config: Config);
    hasWriteAccess(): Promise<boolean>;
    requestHeaders(headers?: {}): Promise<{
        Authorization: string;
        'Content-Type': string;
    }>;
    handleRequestError(error: FetchError & {
        msg: string;
    }, responseStatus: number): void;
    user(): Promise<{
        name: string;
        login: string;
    }>;
    getHeadReference(head: string): Promise<string>;
    commit(message: string, changeTree: {
        parentSha?: string;
        sha: string;
    }): Promise<any>;
    nextUrlProcessor(): (url: string) => string;
    diffFromFile(file: Octokit.ReposCompareCommitsResponseFilesItem): Promise<Diff>;
}
export {};
